%define major 1

%define libname %mklibname %{name}-server %major
%define libnamedev %mklibname %{name}-server -d

Name:		spice
Version:	0.12.5
%define subrel	4
Release:	%mkrel 2
Summary:	Implements the SPICE protocol
Group:		Networking/Remote access
License:	LGPLv2+
URL:		http://www.spice-space.org/
Source0:	http://www.spice-space.org/download/releases/%{name}-%{version}.tar.bz2
Source1:	spice-xpi-client-spicec

Patch38:	0038-Avoid-race-conditions-reading-monitor-configs-from-g.patch

Patch41:	0041-Define-a-constant-to-limit-data-from-guest.patch
Patch42:	0042-Fix-some-integer-overflow-causing-large-memory-alloc.patch
Patch43:	0043-Check-properly-surface-to-be-created.patch
Patch44:	0044-Fix-buffer-reading-overflow.patch
Patch45:	0045-Prevent-32-bit-integer-overflow-in-bitmap_consistent.patch
Patch46:	0046-Fix-race-condition-on-red_get_clip_rects.patch
Patch47:	0047-Fix-race-in-red_get_image.patch
Patch48:	0048-Fix-race-condition-in-red_get_string.patch
Patch49:	0049-Fix-integer-overflow-computing-glyph_size-in-red_get.patch
Patch50:	0050-Fix-race-condition-in-red_get_data_chunks_ptr.patch
Patch51:	0051-Prevent-memory-leak-if-red_get_data_chunks_ptr-fails.patch
Patch52:	0052-Prevent-DoS-from-guest-trying-to-allocate-too-much-d.patch
Patch53:	0053-Fix-some-possible-overflows-in-red_get_string-for-32.patch
Patch54:	0054-Make-sure-we-can-read-QXLPathSeg-structures.patch
Patch55:	0055-Avoid-race-condition-copying-segments-in-red_get_pat.patch
Patch56:	0056-Prevent-data_size-to-be-set-independently-from-data.patch
Patch57:	0057-Prevent-leak-if-size-from-red_get_data_chunks-don-t-.patch
Patch65:	0065-smartcard-add-a-ref-to-item-before-adding-to-pipe.patch
Patch66:	0066-smartcard-allocate-msg-with-the-expected-size.patch
Patch67:	0067-create-a-function-to-validate-surface-parameters.patch
Patch68:	0068-improve-primary-surface-parameter-checks.patch
Patch69:	0069-Prevent-possible-DoS-attempts-during-protocol-handsh.patch
Patch70:	0070-Prevent-integer-overflows-in-capability-checks.patch
Patch71:	0071-main-channel-Prevent-overflow-reading-messages-from-.patch

# https://bugzilla.redhat.com/show_bug.cgi?id=613529
ExclusiveArch:	%{ix86} x86_64

BuildRequires:	pkgconfig
BuildRequires:	spice-protocol >= 0.9.1
BuildRequires:	celt051-devel
BuildRequires:	pixman-devel
BuildRequires:	alsa-lib-devel 
BuildRequires:	openssl-devel 
BuildRequires:	libjpeg-devel
BuildRequires:	pkgconfig(xrandr)
#BuildRequires:	cegui06-devel
BuildRequires:	libcacard-devel
BuildRequires:	libsasl-devel
BuildRequires:	pkgconfig(glib-2.0)
BuildRequires:	pkgconfig(xfixes)
BuildRequires:	pkgconfig(xinerama)
BuildRequires:	python-pyparsing

%description
The Simple Protocol for Independent Computing Environments (SPICE) is
a remote display system built for virtual environments which allows
you to view a computing 'desktop' environment not only on the machine
where it is running, but from anywhere on the Internet and from a wide
variety of machine architectures.

%package client
Summary:	Implements the client side of the SPICE protocol
Group:		Networking/Remote access
Requires(post):	%{_sbindir}/update-alternatives
Requires(postun):	%{_sbindir}/update-alternatives

%description client
The Simple Protocol for Independent Computing Environments (SPICE) is
a remote display system built for virtual environments which allows
you to view a computing 'desktop' environment not only on the machine
where it is running, but from anywhere on the Internet and from a wide
variety of machine architectures.

This package contains the SPICE client application.

%package -n %libname
Summary:	Implements the server side of the SPICE protocol
Group:		System/Libraries

%description -n %libname
The Simple Protocol for Independent Computing Environments (SPICE) is
a remote display system built for virtual environments which allows
you to view a computing 'desktop' environment not only on the machine
where it is running, but from anywhere on the Internet and from a wide
variety of machine architectures.

This package contains the run-time libraries for any application that wishes
to be a SPICE server.

%package -n %libnamedev
Summary:	Header files, libraries and development documentation for spice-server
Group:		Development/C
Requires:	%libname = %{version}-%{release}
Requires:	pkgconfig
Requires:	pkgconfig(libcacard)
Requires:	pkgconfig(xinerama)
Provides:	%name-server-devel = %version-%release


%description -n %libnamedev
This package contains the header files, static libraries and development
documentation for spice-server. If you like to develop programs
using spice-server, you will need to install spice-server-devel.

%prep
%setup -q
%apply_patches

%build
%configure2_5x --enable-smartcard --enable-client --disable-static
%make

%install
%makeinstall_std
rm -f %{buildroot}%{_libdir}/libspice-server.la
mkdir -p %{buildroot}%{_libexecdir}
touch %{buildroot}%{_libexecdir}/spice-xpi-client
install -m 0755 %{SOURCE1} %{buildroot}%{_libexecdir}/

%files client
%doc COPYING README NEWS
%{_bindir}/spicec
%ghost %{_libexecdir}/spice-xpi-client
%{_libexecdir}/spice-xpi-client-spicec

%post client
%{_sbindir}/update-alternatives --install %{_libexecdir}/spice-xpi-client \
  spice-xpi-client %{_libexecdir}/spice-xpi-client-spicec 10

%postun client
if [ $1 -eq 0 ] ; then
  %{_sbindir}/update-alternatives --remove spice-xpi-client %{_libexecdir}/spice-xpi-client-spicec
fi

%files -n %libname
%doc COPYING README NEWS
%{_libdir}/libspice-server.so.%{major}*

%files -n %libnamedev
%{_includedir}/spice-server
%{_libdir}/libspice-server.so
%{_libdir}/pkgconfig/spice-server.pc


%changelog
* Thu Feb 16 2017 ns80 <ns80> 0.12.5-2.4.mga5
+ Revision: 1086448
- add upstream patches for CVE-2016-9577 and CVE-2016-9578 (mga#20251)

  + luigiwalser <luigiwalser>
    - add patches from redhat to fix CVE-2016-0749 and CVE-2016-2150
    - add patches from ubuntu to fix CVE-2015-5260 and CVE-2015-5261
    - add patch from redhat to fix CVE-2015-3247

* Wed Oct 15 2014 umeabot <umeabot> 0.12.5-2.mga5
+ Revision: 740791
- Second Mageia 5 Mass Rebuild

* Sat Jun 28 2014 pterjan <pterjan> 0.12.5-1.mga5
+ Revision: 640760
- Drop patch
- 0.12.5

* Fri Jan 10 2014 luigiwalser <luigiwalser> 0.12.4-4.mga4
+ Revision: 566180
- add upstream patch to fix CVE-2013-4282

* Sat Aug 31 2013 fwang <fwang> 0.12.4-3.mga4
+ Revision: 473660
- rebuild for new sasl

* Tue Aug 27 2013 luigiwalser <luigiwalser> 0.12.4-2.mga4
+ Revision: 472090
- rebuild for cyrus-sasl

* Sun Jul 21 2013 fwang <fwang> 0.12.4-1.mga4
+ Revision: 456778
- cleanup spec
- autoreconf is not required
- new version 0.12.4

* Sun May 26 2013 ovitters <ovitters> 0.12.3-1.mga4
+ Revision: 428117
- drop merged patch
- new version 0.12.3

* Mon Jan 14 2013 umeabot <umeabot> 0.12.2-5.mga3
+ Revision: 382520
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Sun Dec 30 2012 cjw <cjw> 0.12.2-4.mga3
+ Revision: 336347
- patch2: fix build with automake 1.13
  o use the packaged spice-protocol instead of the bundled version

* Tue Dec 25 2012 cjw <cjw> 0.12.2-3.mga3
+ Revision: 334948
- also add pkgconfig(xinerama) dep to -devel pkg to fix pkgconfig(spice-server)

* Tue Dec 25 2012 cjw <cjw> 0.12.2-2.mga3
+ Revision: 334943
- add dependency on pkgconfig(libcacard) to -devel package to fix pkgconfig(spice-server)

* Tue Dec 25 2012 cjw <cjw> 0.12.2-1.mga3
+ Revision: 334859
- 0.12.2
- patch1: fix linkage

* Tue Feb 28 2012 ovitters <ovitters> 0.10.1-1.mga2
+ Revision: 215751
- new version 0.10.1

* Wed Jan 11 2012 ovitters <ovitters> 0.10.0-2.mga2
+ Revision: 194920
- also build for i586

* Wed Jan 11 2012 ovitters <ovitters> 0.10.0-1.mga2
+ Revision: 194838
- fix group
- fix buildrequires
- fix group
- clean spec file
- imported package spice

